#include <bits/stdc++.h>
using namespace std;

int lis_n2(const vector<int> &A) {
    // v čase n^2 vypočítame dĺžku najdlhšej rastúcej podpostupnosti v A
    if (A.empty()) return 0;
    vector<int> B( A.size() );

    for (unsigned i=0; i<A.size(); ++i) {
        B[i] = 1;
        for (unsigned j=0; j<i; ++j) {
            if (A[j] < A[i]) {
                B[i] = max( B[i], 1+B[j] );
            }
        }
    }
    return *max_element( B.begin(), B.end() );
}

int main() {
    int N, E;
    cin >> N >> E;
    vector<int> epizody(N);
    for (int n=0; n<N; ++n) cin >> epizody[n];

    int prva = 0;
    while (prva < N && epizody[prva] != 1) ++prva;
    int posledna = N-1;
    while (posledna >= 0 && epizody[posledna] != E) --posledna;
    if (posledna < prva) {
        cout << -1 << endl;
        return 0;
    }

    vector<int> ostalo;
    for (int i=prva+1; i<posledna; ++i) {
        if (1 < epizody[i] && epizody[i] < E) {
            ostalo.push_back( epizody[i] );
        }
    }
    cout << 2 + lis_n2(ostalo) << endl;
}
